<template>
    <button
        class="button"
        :class="classes"
        :disabled="disabled"
    >
        <div
            v-if="$slots.icon"
            class="button__icon"
            :class="{'v-button__icon_right-margin': $slots.default}"
        >
            <slot name="icon"></slot>
        </div>
        <span
            v-if="$slots.default"
            class="button__label"
        >
            <slot></slot>
        </span>
    </button>
</template>

<script>
export default {
    name: 'button',

    props: {
        view: {
            type    : String,
            default : 'filled',
            validate: val => ['filled', 'outlined'].includes(val)
            // filled - голубая закрашенная, outlined - прозрачная с бордером
        },

        size: {
            type    : String,
            default : 'small',
            validate: val => ['medium', 'small'].includes(val)
        },

        color: {
            type    : String,
            default : 'transparent',
            validate: val => ['transparent', 'blue'].includes(val)
        },

        disabled: {
            type   : Boolean,
            default: false
        }
    },

    computed: {
        classes() {
            const classes = [`button_${this.size}`];

            if (this.view !== 'filled') {
                classes.push(`button_${this.view}`);
            }

            if (this.view === 'filled') {
                classes.push(`button_${this.color}`);
            }

            if (!this.$slots.icon) {
                classes.push('button_text');
            }

            if (!this.$slots.default) {
                classes.push('button_icon');
            }

            if (this.$slots.icon && this.$slots.default) {
                classes.push('button_text_icon');
            }

            return classes;
        }
    }
};
</script>

